﻿using Syncfusion.SfMaps.XForms;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Reflection;
using Xamarin.Forms;

namespace Maps_Demo
{
    public partial class MainPage : ContentPage
    {
        MapViewModel model = new MapViewModel();
        public MainPage()
        {
            InitializeComponent();
            this.BindingContext = model;
        }
    }

    public class MapViewModel : INotifyPropertyChanged
    {
        public ObservableCollection<MapMarker> MapPushPins { get; set; } = new ObservableCollection<MapMarker>();

        public MapViewModel()
        {
            this.MapPushPins.Add(new CustomMarker() {Latitude = "38.8833",Longitude = "-77.0167"});
            this.MapPushPins.Add(new CustomMarker() { Latitude = "-15.7833", Longitude = "-47.866" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "21.0000", Longitude = "78.0000" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "35.0000", Longitude = "103.0000" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "-6.1750", Longitude = "106.8283" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "27.142257", Longitude = "78.283900" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "24.851550", Longitude = "85.222267" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "20.829721", Longitude = "78.269421" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "18.595924", Longitude = "72.999775" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "28.180174", Longitude = "77.389346" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "22.422877", Longitude = "75.940193" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "26.463197", Longitude = "74.487305" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "22.544692", Longitude = "84.547281" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "27.246490", Longitude = "71.988654" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "11.849431", Longitude = "79.892403" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "9.315376", Longitude = "76.906270" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "10.008522", Longitude = "79.716748" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "19.928598", Longitude = "78.135854" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "7.402415", Longitude = "80.946332" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "32.358309", Longitude = "59.340785" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "32.901113", Longitude = "86.040323" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "40", Longitude = "-101" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "-15.7833", Longitude = "-52" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "-1.6", Longitude = "24.4" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "49.9", Longitude = "72.23" });
            this.MapPushPins.Add(new CustomMarker() { Latitude = "-20.54", Longitude = "134.10" });

        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }


    public class CustomMarker : MapMarker
    {
        public ImageSource ImageName { get; set; }
        public CustomMarker()
        {
            if (Device.RuntimePlatform == Device.UWP)
            {
                ImageName = ImageSource.FromResource("Maps-Demo.Icons.pin.png", typeof(CustomMarker).GetTypeInfo().Assembly);
            }
            else
            {
                ImageName = ImageSource.FromResource("Maps-Demo.Icons.pin.png");
            }
        }
    }
}
